/**
 * @file boost/mirror/pre_registered/type/std/string.hpp
 * @brief Pre-registration of the native C++ string types with Mirror
 *
 *  Copyright 2008-2010 Matus Chochlik. Distributed under the Boost
 *  Software License, Version 1.0. (See accompanying file
 *  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef BOOST_MIRROR_PRE_REGISTERED_TYPE_STD_STRING_1011291729_HPP
#define BOOST_MIRROR_PRE_REGISTERED_TYPE_STD_STRING_1011291729_HPP

#include <boost/mirror/meta_type.hpp>
#include <boost/mirror/pre_registered/namespace/std.hpp>
#include <string>

BOOST_MIRROR_REG_BEGIN

BOOST_MIRROR_REG_TYPE_CTS(std, string, ('s','t','r','i','n','g'))
BOOST_MIRROR_REG_TYPE_CTS(std, wstring, ('w','s','t','r','i','n','g'))

BOOST_MIRROR_REG_END

#endif //include guard

